using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.Security.Entity
 {
    [TypeScript]
    [Table("security_user_web_page_preference")]
    public class SecurityUserWebPagePreferenceEntity : EntityBase<SecurityUserWebPagePreferenceEntityKey>
    {

    public SecurityUserWebPagePreferenceEntity() 
    {
    }

    [Column("created_datetime")]
    public DateTime CreatedDatetime  { get; set; }
    [Column("created_by")]
    public string CreatedBy  { get; set; }
    [Column("updated_datetime")]
    public DateTime UpdatedDatetime  { get; set; }
    [Column("updated_by")]
    public string UpdatedBy  { get; set; }
    [Column("username")]
    public string Username  { get; set; }
    [Column("preference_key")]
    public string PreferenceKey  { get; set; }
    [Column("profile_name")]
    public string ProfileName  { get; set; }
    [Column("preference")]
    public string? Preference  { get; set; }
    [Column("default_indc")]
    public string? DefaultIndc  { get; set; }

    public const string CREATED_DATETIME = "CreatedDatetime";
    public const string CREATED_BY = "CreatedBy";
    public const string UPDATED_DATETIME = "UpdatedDatetime";
    public const string UPDATED_BY = "UpdatedBy";
    public const string USERNAME = "Username";
    public const string PREFERENCE_KEY = "PreferenceKey";
    public const string PROFILE_NAME = "ProfileName";
    public const string PREFERENCE = "Preference";
    public const string DEFAULT_INDC = "DefaultIndc";

    public const string DB_NAME_SECURITY_USER_WEB_PAGE_PREFERENCE = "security_user_web_page_preference";
    public const string DB_NAME_FIELDS="created_datetime,created_by,updated_datetime,updated_by,username,preference_key,profile_name,preference,default_indc";

    public const string DB_CREATED_DATETIME = "created_datetime";
    public const string DB_CREATED_BY = "created_by";
    public const string DB_UPDATED_DATETIME = "updated_datetime";
    public const string DB_UPDATED_BY = "updated_by";
    public const string DB_USERNAME = "username";
    public const string DB_PREFERENCE_KEY = "preference_key";
    public const string DB_PROFILE_NAME = "profile_name";
    public const string DB_PREFERENCE = "preference";
    public const string DB_DEFAULT_INDC = "default_indc";


    public static SecurityUserWebPagePreferenceEntity GetInstance()
    {
        return new SecurityUserWebPagePreferenceEntity();
    }

    public virtual void CopyFrom(SecurityUserWebPagePreferenceEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(SecurityUserWebPagePreferenceEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        this.Username =  source.Username;
        this.PreferenceKey =  source.PreferenceKey;
        this.ProfileName =  source.ProfileName;
        this.Preference =  source.Preference;
        this.DefaultIndc =  source.DefaultIndc;

        if (includeSystemFields)
        {
        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_SECURITY_USER_WEB_PAGE_PREFERENCE}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_SECURITY_USER_WEB_PAGE_PREFERENCE}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
            if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_USERNAME ;  		
		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_SECURITY_USER_WEB_PAGE_PREFERENCE}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public SecurityUserWebPagePreferenceEntity Clone()
    {
        SecurityUserWebPagePreferenceEntity result = new SecurityUserWebPagePreferenceEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
